package design.patterns.behavioural.chainofresponsibility;

public abstract class Handler {

    protected Handler nextHandler;
    protected int denomination;

    public void setNextHandler(Handler handler) {
        this.nextHandler = handler;
    }

    public void handle(int balance) {
        int amountOfBill = balance / denomination;
        int remainder = balance % denomination;

        if (remainder > 0) {
            this.nextHandler.handle(remainder);
        }

        System.out.println(amountOfBill + " piece of $" + denomination);
    }

}
